//+------------------------------------------------------------------+
//|                                          10.2 TmaSlope v.1.4.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, zznbrm"

//Edited by shahrooz "sh.sadeghi.me@gmail.com"
//Edited by Nanningbob April 2012 for 10.2                           
//---- indicator settings

#import "user32.dll"
   int      PostMessageA(int hWnd,int Msg,int wParam,int lParam);
#import
 
#define BARS            33018
#define CANDLES         33019
#define LINE            33022
#define WM_COMMAND      0x0111

#property indicator_separate_window
#property  indicator_buffers     8
#property  indicator_level1      0.4
#property  indicator_level2      -0.4 
#property  indicator_level3      0.8 
#property  indicator_level4      -0.8 
#property  indicator_levelcolor  DimGray

#property indicator_color1 Yellow
#property indicator_color2 DarkBlue
#property indicator_color3 Green
#property indicator_color4 Lime
#property indicator_color5 FireBrick
#property indicator_color6 Red
#property indicator_color7 Teal
#property indicator_color8 HotPink


#property indicator_width1 2   
#property indicator_width2 0   
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 3  
#property indicator_width8 3  


//---- input parameters
extern bool ShowOtherTF = true; //Show higher TMA Slope - yellow line
extern bool ShowVerbsInfo = true; //Show Verb's CODEX 1.5 Sell/Buy info (ignore Pivots & R/S)
extern bool SwitchCandlesBars = true; //for TF<=H1 switch chart to BARS mode, beacouse of using Synergy APB under Bars
                                      //for TF>H1 switch chart to CANDLE mode.
extern int eintPeriod = 20;
extern double edblHigh2 = 0.8;
extern double edblHigh1 = 0.4;
extern double edblLow1 = -0.4;
extern double edblLow2 = -0.8;
extern int atrPeriod = 100;

extern int Info_Corner=3;
extern string Info_Font = "Arial";
extern int Info_Font_Size = 12;
extern int Info_H_Pos =1;
extern int Info_V_Pos_MTF=50;
extern int Info_V_Pos = 25;
extern int Info_V_Pos_Verb = 1;

//---- indicator buffers
double gadblUp1[];
double gadblUp2[];

double gadblDn1[];
double gadblDn2[];

double gadblMid1[];
double gadblMid2[];

double gadblSlope[]; 
double gadblSlopeMTF[]; 
color Font_Color_M15;

int OtherTF;
double TICK;
bool AdditionalDigit;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{              
   IndicatorBuffers( 8 );
   IndicatorDigits( 5 );
   IndicatorShortName( "10.2 TmaSlope_Norm" );
      
   SetIndexBuffer( 0, gadblSlopeMTF );  
   SetIndexBuffer( 1, gadblSlope );  SetIndexLabel( 1,"TMA Slope");  SetIndexStyle( 1, DRAW_NONE );
   SetIndexBuffer( 2, gadblUp1 );    SetIndexLabel( 1, NULL );       SetIndexStyle( 2, DRAW_HISTOGRAM );
   SetIndexBuffer( 3, gadblUp2 );    SetIndexLabel( 2, NULL );       SetIndexStyle( 3, DRAW_HISTOGRAM );
   SetIndexBuffer( 4, gadblDn1 );    SetIndexLabel( 3, NULL );       SetIndexStyle( 4, DRAW_HISTOGRAM );
   SetIndexBuffer( 5, gadblDn2 );    SetIndexLabel( 4, NULL );       SetIndexStyle( 5, DRAW_HISTOGRAM );
   SetIndexBuffer( 6, gadblMid1 );   SetIndexLabel( 5, NULL );       SetIndexStyle( 6, DRAW_HISTOGRAM );
   SetIndexBuffer( 7, gadblMid2 );   SetIndexLabel( 6, NULL );       SetIndexStyle( 7, DRAW_HISTOGRAM );
   if (ShowOtherTF) { 
      SetIndexStyle( 0, DRAW_LINE );
      SetIndexLabel( 0, "Other TF TMA Slope" );
      switch(Period())
      {
         case 1 : OtherTF=5; break;
         case 5 : OtherTF=15; break;
         case 15 : OtherTF=60; break;
         case 30 : OtherTF=240; break;
         case 60 : OtherTF=240; break;
         case 240 : OtherTF=1440; break;
         case 1440 : OtherTF=10080; break;
         case 10080 : OtherTF=43200; break;
         case 43200 : OtherTF=43200; break;
         default : OtherTF=0;
      } 
      ObjectCreate("TMA_label_MTF",OBJ_LABEL,WindowFind("10.2 TmaSlope_Norm"),0,0);
      ObjectSet("TMA_label_MTF",OBJPROP_XDISTANCE,Info_H_Pos);
      ObjectSet("TMA_label_MTF",OBJPROP_YDISTANCE,Info_V_Pos_MTF);
      ObjectSet("TMA_label_MTF",OBJPROP_CORNER,Info_Corner);
   } 
   else { 
      SetIndexStyle( 0, DRAW_NONE );
   }
   if (Period()==OtherTF) {
      SetIndexStyle( 0, DRAW_NONE );
      ObjectDelete("TMA_label_MTF");
   }    
   if (SwitchCandlesBars){
      if (Period()>60) PostMessageA( WindowHandle( Symbol(), Period() ), WM_COMMAND, CANDLES, 0 );
      else  PostMessageA( WindowHandle( Symbol(), Period() ), WM_COMMAND, BARS, 0 );
   }
   ObjectCreate("TMA_label",OBJ_LABEL,WindowFind("10.2 TmaSlope_Norm"),0,0);
   ObjectSet("TMA_label",OBJPROP_XDISTANCE,Info_H_Pos);
   ObjectSet("TMA_label",OBJPROP_YDISTANCE,Info_V_Pos);
   ObjectSet("TMA_label",OBJPROP_CORNER,Info_Corner);
   if (ShowVerbsInfo){
      ObjectCreate("Verbs_info",OBJ_LABEL,WindowFind("10.2 TmaSlope_Norm"),0,0);
      ObjectSet("Verbs_info",OBJPROP_XDISTANCE,Info_H_Pos);
      ObjectSet("Verbs_info",OBJPROP_YDISTANCE,Info_V_Pos_Verb);
      ObjectSet("Verbs_info",OBJPROP_CORNER,Info_Corner);
      ObjectSetText("Verbs_info"," ", Info_Font_Size, Info_Font, Yellow);
   }
   return( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete("TMA_label_MTF");
   ObjectDelete("TMA_label");
   ObjectDelete("Verbs_info");
   return( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int cb = IndicatorCounted();
   if ( cb < 0 ) return(-1);
   if ( cb > 0 ) cb--;
   int intLimit = MathMin( Bars - 1, Bars - cb + eintPeriod );
   double atr ; 
   double atrMTF ;
   string VInfo;
   color VerbColor=Gray;
   for( int inx = intLimit; inx >= 0; inx-- ) {
      atr= iATR(NULL,0,atrPeriod,inx+10)*0.1;
      atrMTF= iATR(NULL,OtherTF,atrPeriod,inx+10)*0.1;
      if (atr == 0) continue;
      if (atrMTF == 0) continue;
      gadblSlope[inx] = ( calcTma( inx ) - calcTma( inx+1 ) ) / atr;
      gadblUp1[inx] = 0.0;   
      gadblDn1[inx] = 0.0;     
      gadblMid1[inx] = 0.0;   
      gadblUp2[inx] = 0.0;   
      gadblDn2[inx] = 0.0;     
      gadblMid2[inx] = 0.0;   
      if ( gadblSlope[inx] > edblHigh1 ) {
         if(gadblSlope[inx] < gadblSlope[inx+1]) gadblUp1[inx] = gadblSlope[inx];
         else gadblUp2[inx] = gadblSlope[inx];
      }
      else if ( gadblSlope[inx] < edblLow1 ) {
         if(gadblSlope[inx] < gadblSlope[inx+1]) gadblDn2[inx] = gadblSlope[inx];
         else gadblDn1[inx] = gadblSlope[inx];
      }
      else {
         if(gadblSlope[inx] < gadblSlope[inx+1]) gadblMid2[inx] = gadblSlope[inx];
         else gadblMid1[inx] = gadblSlope[inx];
      } 
      if (ShowOtherTF) { 
         int OtherTFBar=iBarShift(Symbol(),OtherTF,Time[inx]);
         gadblSlopeMTF[inx] = ( calcTmaMTF( OtherTFBar , OtherTF ) - calcTmaMTF( OtherTFBar+1 , OtherTF) ) / atrMTF;
      } else gadblSlopeMTF[inx]=gadblSlope[inx];
   }
   string tt=TF_Name(Period())+" = "+DoubleToStr(gadblSlope[0],2);
   if (gadblSlope[0] >= edblHigh2)
      ObjectSetText("TMA_label", tt+" Str.Buy", Info_Font_Size, Info_Font, Lime);
   else if (gadblSlope[0] >= edblHigh1)
      ObjectSetText("TMA_label", tt+" Buy", Info_Font_Size, Info_Font, Green);
   else if (gadblSlope[0] <= edblLow2)
      ObjectSetText("TMA_label", tt+" Str.Sell", Info_Font_Size, Info_Font, Red);
   else if (gadblSlope[0] <= edblLow1)
      ObjectSetText("TMA_label", tt+" Sell", Info_Font_Size, Info_Font, FireBrick);
   else 
      ObjectSetText("TMA_label", tt+" Ranging", Info_Font_Size, Info_Font, Gray);
   if (ShowOtherTF) { 
      tt=TF_Name(OtherTF)+" = "+DoubleToStr(gadblSlopeMTF[0],2);
      if (gadblSlopeMTF[0] >= edblHigh2)
         ObjectSetText("TMA_label_MTF", tt+" Str.Buy", Info_Font_Size, Info_Font, Lime);
      else if (gadblSlopeMTF[0] >= edblHigh1)
         ObjectSetText("TMA_label_MTF", tt+" Buy", Info_Font_Size, Info_Font, Green);
      else if (gadblSlopeMTF[0] <= edblLow2)
         ObjectSetText("TMA_label_MTF", tt+" Str.Sell", Info_Font_Size, Info_Font, Red);
      else if (gadblSlopeMTF[0] <= edblLow1)
         ObjectSetText("TMA_label_MTF", tt+" Sell", Info_Font_Size, Info_Font, FireBrick);
      else 
         ObjectSetText("TMA_label_MTF", tt+" Ranging", Info_Font_Size, Info_Font, Gray);
   }
   if (ShowVerbsInfo){
      VInfo=" ";
      double WOH2=iCustom(NULL, Period(), "10.2 WeeklyOpenHistogramMod 2x1 4.29", 1000, 3, 0);
      double WOH1=iCustom(NULL, Period(), "10.2 WeeklyOpenHistogramMod 1x0 4.29", 1000, 3, 0);
      if (Period()==PERIOD_D1){
         VInfo="D1Verb = Wait";
         if (gadblSlope[0] >= edblHigh1 && WOH2>0){
            VInfo="D1Verb = Buy";
            VerbColor=Green;
            if (gadblSlopeMTF[0] >= edblHigh1) {VInfo="D1Verb = Buy A"; VerbColor=Lime;}
         }
         if (gadblSlope[0] <= edblLow1 && WOH2<0){
            VInfo="D1Verb = Sell";
            VerbColor=FireBrick;
            if (gadblSlopeMTF[0] <= edblLow1) {VInfo="D1Verb = Sell A"; VerbColor=Red;}
         }
      }
      if (Period()==PERIOD_H4){
         VInfo="H4Verb = Wait";
         if (WOH2>0){
            if (gadblSlope[0] >= edblHigh1 && gadblSlopeMTF[0] >= edblHigh1 && WOH1>0) {VInfo="H4Verb = Buy"; VerbColor=Green;}
            if (gadblSlope[0] >= edblHigh2 && gadblSlopeMTF[0] >= edblHigh2 && WOH1<0) {VInfo="H4Verb = Buy A"; VerbColor=Lime;}
         }
         if (WOH2<0){
            if (gadblSlope[0] <= edblLow1 && gadblSlopeMTF[0] <= edblLow1 && WOH1<0) {VInfo="H4Verb = Sell"; VerbColor=FireBrick;}
            if (gadblSlope[0] <= edblLow2 && gadblSlopeMTF[0] <= edblLow2 && WOH1>0) {VInfo="H4Verb = Sell A"; VerbColor=Red;}
         }
      }
      if (Period()==PERIOD_H1){
         VInfo="H1Verb = Wait";
         double atrD1= iATR(NULL,PERIOD_D1,atrPeriod,10)*0.1;
         double D1Slope = ( calcTmaMTF( 0 , PERIOD_D1 ) - calcTmaMTF( 1 , PERIOD_D1) ) / atrD1;
         if (WOH2>0 && gadblSlopeMTF[0] >= edblHigh1 && D1Slope >= edblHigh1){
            if (gadblSlope[0] >= edblLow1)  {VInfo="H1Verb = Buy"; VerbColor=Green;}
            if (gadblSlope[0] >= 0 && WOH1<0)  {VInfo="H1Verb = Buy A"; VerbColor=Lime;}
         }
         if (WOH2<0 && gadblSlopeMTF[0] <= edblLow1 && D1Slope <= edblLow1){
            if (gadblSlope[0] <= edblHigh1)  {VInfo="H1Verb = Sell"; VerbColor=FireBrick;}
            if (gadblSlope[0] <= 0 && WOH1>0)  {VInfo="H1Verb = Sell A"; VerbColor=Red;}
         }
      }
      ObjectSetText("Verbs_info", VInfo, Info_Font_Size, Info_Font, VerbColor);
   }
   return( 0 );
}

//+------------------------------------------------------------------+
//| calcTma()                                                        |
//+------------------------------------------------------------------+
double calcTma( int inx )
{
   double dblSum  = (eintPeriod+1)*Close[inx];
   double dblSumw = (eintPeriod+1);
   int jnx, knx;
   for ( jnx = 1, knx = eintPeriod; jnx <= eintPeriod; jnx++, knx-- ) {
      dblSum  += ( knx * Close[inx+jnx] );
      dblSumw += knx;
      if ( jnx <= inx ) {
         dblSum  += ( knx * Close[inx-jnx] );
         dblSumw += knx;
      }
   }
   return( dblSum / dblSumw );
}
 
 
 double calcTmaMTF( int inx , int tf)
{
   double dblSum  = (eintPeriod+1)*iClose(Symbol(),tf,inx);
   double dblSumw = (eintPeriod+1);
   int jnx, knx;
   for ( jnx = 1, knx = eintPeriod; jnx <= eintPeriod; jnx++, knx-- ) {
      dblSum  += ( knx * iClose(Symbol(),tf,inx+jnx) );
      dblSumw += knx;
      if ( jnx <= inx ) {
         dblSum  += ( knx * iClose(Symbol(),tf,inx-jnx) );
         dblSumw += knx;
      }
   }
   return( dblSum / dblSumw );
}

string TF_Name(int tf)
{
      switch(tf)
      {
         case 1 : return("M1"); break;
         case 5 : return("M5"); break;
         case 15 : return("M15"); break;
         case 30 : return("M30"); break;
         case 60 : return("H1"); break;
         case 240 : return("H4"); break;
         case 1440 : return("D1"); break;
         case 10080 : return("W1"); break;
         case 43200 : return("MN1"); break;
         default : return("Current");
      } 
   return("");
} 
 
 
 
 
 
 
 
 
 
 
 



   


